diff --git a/src/main/java/net/minecraft/core/net/command/commands/SpawnParticleCommand.java b/src/main/java/net/minecraft/core/net/command/commands/SpawnParticleCommand.java
index aeffaf830..74a1cd079 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/SpawnParticleCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/SpawnParticleCommand.java
@@ -1,12 +1,12 @@
 package net.minecraft.core.net.command.commands;
 
-import net.minecraft.client.entity.fx.ParticleDispatcher;
+import net.minecraft.client.entity.particle.ParticleDispatcher;
 import net.minecraft.core.net.command.ClientCommandHandler;
 import net.minecraft.core.net.command.Command;
 import net.minecraft.core.net.command.CommandHandler;
 import net.minecraft.core.net.command.CommandSender;
 import net.minecraft.core.net.command.ServerCommandHandler;
-import net.minecraft.core.net.packet.Packet63SpawnParticleEffect;
+import net.minecraft.core.net.packet.AddParticlePacket;
 
 public class SpawnParticleCommand extends Command {
     public SpawnParticleCommand() {
@@ -62,7 +62,7 @@ public class SpawnParticleCommand extends Command {
         }
         if (particleKey != null && x != null){
             if (handler instanceof ServerCommandHandler){
-                ((ServerCommandHandler) handler).minecraftServer.playerList.sendPacketToPlayersAroundPoint(x, y, z, maxDistance == null ? 16 : maxDistance, dimension, new Packet63SpawnParticleEffect(particleKey, x, y, z, motionX, motionY, motionZ, data));
+                ((ServerCommandHandler) handler).minecraftServer.playerList.sendPacketToPlayersAroundPoint(x, y, z, maxDistance == null ? 16 : maxDistance, dimension, new AddParticlePacket(particleKey, x, y, z, motionX, motionY, motionZ, data));
             } else if (handler instanceof ClientCommandHandler){
                 if (maxDistance == null){
                     ((ClientCommandHandler) handler).minecraft.renderGlobal.addParticle(particleKey, x, y, z, motionX, motionY, motionZ, data);
diff --git a/src/main/java/net/minecraft/core/net/command/commands/TeleportCommand.java b/src/main/java/net/minecraft/core/net/command/commands/TeleportCommand.java
index 910d7dc38..f60a7f9dd 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/TeleportCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/TeleportCommand.java
@@ -1,8 +1,8 @@
 package net.minecraft.core.net.command.commands;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.server.entity.player.EntityPlayerMP;
+import net.minecraft.server.entity.player.ServerPlayer;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.command.Command;
 import net.minecraft.core.net.command.CommandError;
@@ -27,8 +27,8 @@ public class TeleportCommand extends Command{
 		
 		if(args.length > 0) {
 			if(args.length <= 2) {
-				EntityPlayer from = null;
-				EntityPlayer to = null;
+				Player from = null;
+				Player to = null;
 				
 				if(args.length == 1) {
 					if(sentByPlayer) {
@@ -47,7 +47,7 @@ public class TeleportCommand extends Command{
 				return true;
 			}
 			
-			EntityPlayer player = null;
+			Player player = null;
 			double x = 0.0;
 			double y = 0.0;
 			double z = 0.0;
@@ -82,8 +82,8 @@ public class TeleportCommand extends Command{
 		}
 	}
 	
-	public EntityPlayer getPlayer(CommandHandler handler, String name) {
-		EntityPlayer player = handler.getPlayer(name);
+	public Player getPlayer(CommandHandler handler, String name) {
+		Player player = handler.getPlayer(name);
 		if(player == null) throw new CommandError("Player not found: "+name);
 		return player;
 	}
@@ -104,10 +104,10 @@ public class TeleportCommand extends Command{
 		return true;
 	}
 	
-	public static void teleport(CommandHandler handler, CommandSender sender, EntityPlayer p1, Integer dimension, double x, double y, double z, double yaw, double pitch, EntityPlayer p2) {
-		if(p1 instanceof EntityPlayerMP) {
+	public static void teleport(CommandHandler handler, CommandSender sender, Player p1, Integer dimension, double x, double y, double z, double yaw, double pitch, Player p2) {
+		if(p1 instanceof ServerPlayer) {
 			
-			EntityPlayerMP p1MP = (EntityPlayerMP) p1;
+			ServerPlayer p1MP = (ServerPlayer) p1;
 			if(dimension != null && p1MP.dimension != dimension && handler instanceof ServerCommandHandler) {
 				ServerCommandHandler serverCommandHandler = (ServerCommandHandler) handler;
 				serverCommandHandler.minecraftServer.playerList.sendPlayerToOtherDimension(p1MP, dimension, false);
@@ -124,7 +124,7 @@ public class TeleportCommand extends Command{
 		}
 	}
 	
-	public static void teleport(CommandHandler handler, CommandSender sender, EntityPlayer p1, EntityPlayer p2) {
+	public static void teleport(CommandHandler handler, CommandSender sender, Player p1, Player p2) {
 		teleport(handler, sender, p1, p2.dimension, p2.x, p2.y, p2.z, p2.yRot, p2.xRot, p2);
 	}
 	
diff --git a/src/main/java/net/minecraft/core/net/command/commands/WeatherCommand.java b/src/main/java/net/minecraft/core/net/command/commands/WeatherCommand.java
index 99e2cdb82..33acbc9fa 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/WeatherCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/WeatherCommand.java
@@ -7,6 +7,7 @@ import net.minecraft.core.net.command.CommandSender;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.weather.Weather;
+import net.minecraft.core.world.weather.Weathers;
 
 public class WeatherCommand extends Command{
 
@@ -26,7 +27,7 @@ public class WeatherCommand extends Command{
 			weatherString.append(TextFormatting.LIGHT_GRAY + "Available weathers: " + TextFormatting.WHITE);
 			weatherString.append("clear");
 			
-			for(Weather weather : Weather.weatherList) {
+			for(Weather weather : Weathers.WEATHERS) {
 				if(weather != null) {
 					weatherString.append(", ");
 					weatherString.append(weather.languageKey.substring(8));
@@ -94,7 +95,7 @@ public class WeatherCommand extends Command{
 	
 	public static Weather getWeather(String string, World world) {
 		try {
-			return Weather.getWeather(Integer.parseInt(string));
+			return Weathers.getWeather(Integer.parseInt(string));
 		}catch (NumberFormatException e) {}
 
 		if(string.equalsIgnoreCase("clear")) {
@@ -105,7 +106,7 @@ public class WeatherCommand extends Command{
 			return weather;
 		}
 		
-		return Weather.getWeatherByLanguageKey(string);
+		return Weathers.getWeatherByLanguageKey(string);
 	}
 
 }
diff --git a/src/main/java/net/minecraft/core/net/command/commands/WhisperCommand.java b/src/main/java/net/minecraft/core/net/command/commands/WhisperCommand.java
index 43efc15ad..eb6a16c54 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/WhisperCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/WhisperCommand.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.net.command.commands;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.command.Command;
 import net.minecraft.core.net.command.CommandHandler;
@@ -17,7 +17,7 @@ public class WhisperCommand extends Command{
 		if(args.length < 2) {
 			return false;
 		}
-		EntityPlayer player = handler.getPlayer(args[0]);
+		Player player = handler.getPlayer(args[0]);
 		
 		StringBuilder builder = new StringBuilder();
 		
diff --git a/src/main/java/net/minecraft/core/net/command/servercommands/BanCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/BanCommand.java
new file mode 100644
index 000000000..d4c04e74a
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/BanCommand.java
@@ -0,0 +1,42 @@
+package net.minecraft.core.net.command.servercommands;
+
+import net.minecraft.client.entity.player.RemotePlayer;
+import net.minecraft.core.net.command.CommandHandler;
+import net.minecraft.core.net.command.CommandSender;
+import net.minecraft.core.net.command.ServerCommand;
+import net.minecraft.server.MinecraftServer;
+import net.minecraft.server.entity.player.ServerPlayer;
+
+public class BanCommand extends ServerCommand {
+    public BanCommand(MinecraftServer server) {
+        super(server, "ban");
+    }
+
+    @Override
+    public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
+        if (args.length != 1) return false;
+        String senderName = sender.getName();
+
+        String nameToBan = args[0];
+
+        server.playerList.banPlayer(nameToBan);
+        sendNoticeToOps(senderName, "Banning " + nameToBan);
+        ServerPlayer player = server.playerList.getPlayerEntity(nameToBan);
+        if(player != null)
+        {
+            player.playerNetServerHandler.kickPlayer("Banned by admin");
+        }
+
+        return true;
+    }
+
+    @Override
+    public boolean opRequired(String[] args) {
+        return true;
+    }
+
+    @Override
+    public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
+        sender.sendMessage("/ban <username>");
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/servercommands/BanIpCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/BanIpCommand.java
new file mode 100644
index 000000000..9e990b52f
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/BanIpCommand.java
@@ -0,0 +1,42 @@
+package net.minecraft.core.net.command.servercommands;
+
+import net.minecraft.core.net.command.CommandHandler;
+import net.minecraft.core.net.command.CommandSender;
+import net.minecraft.core.net.command.ServerCommand;
+import net.minecraft.server.MinecraftServer;
+import net.minecraft.server.entity.player.ServerPlayer;
+
+public class BanIpCommand extends ServerCommand {
+    public BanIpCommand(MinecraftServer server) {
+        super(server, "ban-ip");
+    }
+
+    @Override
+    public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
+        if (args.length != 1) return false;
+        String senderName = sender.getName();
+
+        String nameToBan = args[0];
+        server.playerList.banIP(nameToBan);
+        
+        sendNoticeToOps(senderName, "Banning ip " + nameToBan);
+
+        ServerPlayer player = server.playerList.getPlayerEntity(nameToBan);
+        if(player != null)
+        {
+            player.playerNetServerHandler.kickPlayer("Banned by admin");
+        }
+
+        return true;
+    }
+
+    @Override
+    public boolean opRequired(String[] args) {
+        return true;
+    }
+
+    @Override
+    public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
+        sender.sendMessage("/ban-ip <username>");
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/commands/ColorCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/ColorCommand.java
similarity index 83%
rename from src/main/java/net/minecraft/core/net/command/commands/ColorCommand.java
rename to src/main/java/net/minecraft/core/net/command/servercommands/ColorCommand.java
index 5ae3852be..5c11a6ea7 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/ColorCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/ColorCommand.java
@@ -1,8 +1,8 @@
-package net.minecraft.core.net.command.commands;
+package net.minecraft.core.net.command.servercommands;
 
 import net.minecraft.server.MinecraftServer;
-import net.minecraft.server.entity.player.EntityPlayerMP;
-import net.minecraft.core.net.packet.Packet72UpdatePlayerProfile;
+import net.minecraft.server.entity.player.ServerPlayer;
+import net.minecraft.core.net.packet.UpdatePlayerProfilePacket;
 import net.minecraft.core.net.command.*;
 
 public class ColorCommand extends ServerCommand {
@@ -14,7 +14,7 @@ public class ColorCommand extends ServerCommand {
 	@Override
 	public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
 		if(!sender.isPlayer()) throw new CommandError("Must be used by a player!");
-		EntityPlayerMP player = (EntityPlayerMP) sender.getPlayer();
+		ServerPlayer player = (ServerPlayer) sender.getPlayer();
 		
 		if(args.length == 0) {
 			{
@@ -57,7 +57,7 @@ public class ColorCommand extends ServerCommand {
 		newColor = (byte) color.id;
 		player.chatColor = newColor;
 		player.hadNicknameSet = true;
-		player.mcServer.playerList.sendPacketToAllPlayers(new Packet72UpdatePlayerProfile(player.username, player.nickname, player.score, newColor, true, player.isOperator()));
+		player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.score, newColor, true, player.isOperator()));
 		sender.sendMessage(TextFormatting.LIGHT_GRAY + "You changed your color to " + color + color.getNames()[0]);
 		return true;
 	}
diff --git a/src/main/java/net/minecraft/core/net/command/commands/DeopCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/DeopCommand.java
similarity index 72%
rename from src/main/java/net/minecraft/core/net/command/commands/DeopCommand.java
rename to src/main/java/net/minecraft/core/net/command/servercommands/DeopCommand.java
index 1bffff740..282120958 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/DeopCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/DeopCommand.java
@@ -1,8 +1,8 @@
-package net.minecraft.core.net.command.commands;
+package net.minecraft.core.net.command.servercommands;
 
 import net.minecraft.server.MinecraftServer;
-import net.minecraft.server.entity.player.EntityPlayerMP;
-import net.minecraft.core.net.packet.Packet72UpdatePlayerProfile;
+import net.minecraft.server.entity.player.ServerPlayer;
+import net.minecraft.core.net.packet.UpdatePlayerProfilePacket;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.command.CommandHandler;
 import net.minecraft.core.net.command.CommandSender;
@@ -27,10 +27,10 @@ public class DeopCommand extends ServerCommand{
 			handler.sendCommandFeedback(sender, "De-opping "+name);
 		}
 
-		EntityPlayerMP player = (EntityPlayerMP) handler.getPlayer(name);
+		ServerPlayer player = (ServerPlayer) handler.getPlayer(name);
 		if(player != null && playerWasOp) {
 			handler.sendMessageToPlayer(player, TextFormatting.YELLOW + "You are no longer op!");
-			player.mcServer.playerList.sendPacketToAllPlayers(new Packet72UpdatePlayerProfile(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
+			player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
 		}
 		
 		return true;
diff --git a/src/main/java/net/minecraft/core/net/command/commands/DifficultyCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/DifficultyCommand.java
similarity index 96%
rename from src/main/java/net/minecraft/core/net/command/commands/DifficultyCommand.java
rename to src/main/java/net/minecraft/core/net/command/servercommands/DifficultyCommand.java
index b326353f2..323fd18be 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/DifficultyCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/DifficultyCommand.java
@@ -1,4 +1,4 @@
-package net.minecraft.core.net.command.commands;
+package net.minecraft.core.net.command.servercommands;
 
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.core.world.World;
diff --git a/src/main/java/net/minecraft/core/net/command/commands/EmotesCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/EmotesCommand.java
similarity index 96%
rename from src/main/java/net/minecraft/core/net/command/commands/EmotesCommand.java
rename to src/main/java/net/minecraft/core/net/command/servercommands/EmotesCommand.java
index 01d8f3a78..c925a40fe 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/EmotesCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/EmotesCommand.java
@@ -1,4 +1,4 @@
-package net.minecraft.core.net.command.commands;
+package net.minecraft.core.net.command.servercommands;
 
 import net.minecraft.core.net.command.CommandHandler;
 import net.minecraft.core.net.command.CommandSender;
diff --git a/src/main/java/net/minecraft/core/net/command/servercommands/KickCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/KickCommand.java
new file mode 100644
index 000000000..7613689a8
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/KickCommand.java
@@ -0,0 +1,50 @@
+package net.minecraft.core.net.command.servercommands;
+
+import net.minecraft.core.net.command.CommandHandler;
+import net.minecraft.core.net.command.CommandSender;
+import net.minecraft.core.net.command.ServerCommand;
+import net.minecraft.server.MinecraftServer;
+import net.minecraft.server.entity.player.ServerPlayer;
+
+public class KickCommand extends ServerCommand {
+    public KickCommand(MinecraftServer server) {
+        super(server, "kick");
+    }
+
+    @Override
+    public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
+        if (args.length != 1) return false;
+        String senderName = sender.getName();
+
+        String nameToKick = args[0];
+
+        ServerPlayer playerToKick = null;
+        for (ServerPlayer playerMP : server.playerList.playerEntities){
+            if(playerMP.username.equalsIgnoreCase(nameToKick))
+            {
+                playerToKick = playerMP;
+                break;
+            }
+        }
+
+        if(playerToKick != null)
+        {
+            playerToKick.playerNetServerHandler.kickPlayer("Kicked by admin");
+            sendNoticeToOps(senderName, "Kicking " + playerToKick.getDisplayName());
+        } else
+        {
+            server.log("Can't find user " + nameToKick + ". No kick attempted.");
+        }
+        return true;
+    }
+
+    @Override
+    public boolean opRequired(String[] args) {
+        return true;
+    }
+
+    @Override
+    public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
+        sender.sendMessage("/kick <username>");
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/commands/ListCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/ListCommand.java
similarity index 95%
rename from src/main/java/net/minecraft/core/net/command/commands/ListCommand.java
rename to src/main/java/net/minecraft/core/net/command/servercommands/ListCommand.java
index f00b7ab4c..34ad7f6f1 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/ListCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/ListCommand.java
@@ -1,4 +1,4 @@
-package net.minecraft.core.net.command.commands;
+package net.minecraft.core.net.command.servercommands;
 
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.core.net.command.CommandHandler;
diff --git a/src/main/java/net/minecraft/core/net/command/MeCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/MeCommand.java
similarity index 70%
rename from src/main/java/net/minecraft/core/net/command/MeCommand.java
rename to src/main/java/net/minecraft/core/net/command/servercommands/MeCommand.java
index a6b4ee3c1..ab3c7fa2c 100644
--- a/src/main/java/net/minecraft/core/net/command/MeCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/MeCommand.java
@@ -1,8 +1,12 @@
-package net.minecraft.core.net.command;
+package net.minecraft.core.net.command.servercommands;
 
+import net.minecraft.core.net.command.CommandHandler;
+import net.minecraft.core.net.command.CommandSender;
+import net.minecraft.core.net.command.ServerCommand;
+import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.server.MinecraftServer;
 
-public class MeCommand extends ServerCommand{
+public class MeCommand extends ServerCommand {
 	
 	public MeCommand(MinecraftServer server) {
 		super(server, "me");
diff --git a/src/main/java/net/minecraft/core/net/command/commands/NicknameCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/NicknameCommand.java
similarity index 85%
rename from src/main/java/net/minecraft/core/net/command/commands/NicknameCommand.java
rename to src/main/java/net/minecraft/core/net/command/servercommands/NicknameCommand.java
index acee986f0..e95b3881e 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/NicknameCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/NicknameCommand.java
@@ -1,8 +1,8 @@
-package net.minecraft.core.net.command.commands;
+package net.minecraft.core.net.command.servercommands;
 
 import net.minecraft.server.MinecraftServer;
-import net.minecraft.server.entity.player.EntityPlayerMP;
-import net.minecraft.core.net.packet.Packet72UpdatePlayerProfile;
+import net.minecraft.server.entity.player.ServerPlayer;
+import net.minecraft.core.net.packet.UpdatePlayerProfilePacket;
 import net.minecraft.core.net.command.*;
 
 public class NicknameCommand extends ServerCommand
@@ -18,7 +18,7 @@ public class NicknameCommand extends ServerCommand
         }
 
 
-        EntityPlayerMP player = (EntityPlayerMP) sender.getPlayer();
+        ServerPlayer player = (ServerPlayer) sender.getPlayer();
 
         if (args[0].equalsIgnoreCase("set"))
         {
@@ -34,7 +34,7 @@ public class NicknameCommand extends ServerCommand
 
             player.nickname = enteredNickname;
             player.hadNicknameSet = true;
-            player.mcServer.playerList.sendPacketToAllPlayers(new Packet72UpdatePlayerProfile(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
+            player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
             sender.sendMessage("You set your nickname to " + player.getDisplayName());
             return true;
         }
@@ -51,13 +51,13 @@ public class NicknameCommand extends ServerCommand
             if (args.length != 1) return false;
             player.nickname = "";
             player.hadNicknameSet = true;
-            player.mcServer.playerList.sendPacketToAllPlayers(new Packet72UpdatePlayerProfile(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
+            player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
             sender.sendMessage("You cleared your nickname.");
             return true;
         }
         else
         {
-            player = (EntityPlayerMP)handler.getPlayer(args[0]);
+            player = (ServerPlayer)handler.getPlayer(args[0]);
             if (player == null) throw new CommandError("Unknown username!");
             if (args.length < 2) return false;
             if (!sender.isAdmin() && !sender.isConsole()) return false;
@@ -74,7 +74,7 @@ public class NicknameCommand extends ServerCommand
 
                 player.nickname = enteredNickname;
                 player.hadNicknameSet = true;
-                player.mcServer.playerList.sendPacketToAllPlayers(new Packet72UpdatePlayerProfile(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
+                player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
                 sender.sendMessage("Set " + player.username + "'s nickname to " + player.getDisplayName());
                 handler.sendMessageToPlayer(player, "Your nickname was set to " + player.getDisplayName());
                 return true;
@@ -90,7 +90,7 @@ public class NicknameCommand extends ServerCommand
                 if (args.length != 2) return false;
                 player.nickname = "";
                 player.hadNicknameSet = true;
-                player.mcServer.playerList.sendPacketToAllPlayers(new Packet72UpdatePlayerProfile(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
+                player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
                 sender.sendMessage("Cleared " + player.username + "'s nickname.");
                 handler.sendMessageToPlayer(player, "Your nickname was cleared.");
                 return true;
diff --git a/src/main/java/net/minecraft/core/net/command/commands/OpCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/OpCommand.java
similarity index 69%
rename from src/main/java/net/minecraft/core/net/command/commands/OpCommand.java
rename to src/main/java/net/minecraft/core/net/command/servercommands/OpCommand.java
index ca7e26058..026b6c8f8 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/OpCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/OpCommand.java
@@ -1,8 +1,8 @@
-package net.minecraft.core.net.command.commands;
+package net.minecraft.core.net.command.servercommands;
 
 import net.minecraft.server.MinecraftServer;
-import net.minecraft.server.entity.player.EntityPlayerMP;
-import net.minecraft.core.net.packet.Packet72UpdatePlayerProfile;
+import net.minecraft.server.entity.player.ServerPlayer;
+import net.minecraft.core.net.packet.UpdatePlayerProfilePacket;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.command.CommandHandler;
 import net.minecraft.core.net.command.CommandSender;
@@ -22,10 +22,10 @@ public class OpCommand extends ServerCommand{
 		server.playerList.opPlayer(name);
 		handler.sendCommandFeedback(sender, "Opping "+name);
 		
-		EntityPlayerMP player = (EntityPlayerMP) handler.getPlayer(name);
+		ServerPlayer player = (ServerPlayer) handler.getPlayer(name);
 		if(player != null) {
 			handler.sendMessageToPlayer(player, TextFormatting.YELLOW + "You are now op!");
-			player.mcServer.playerList.sendPacketToAllPlayers(new Packet72UpdatePlayerProfile(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
+			player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
 		}
 
 		return true;
diff --git a/src/main/java/net/minecraft/core/net/command/servercommands/PardonCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/PardonCommand.java
new file mode 100644
index 000000000..b15372123
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/PardonCommand.java
@@ -0,0 +1,35 @@
+package net.minecraft.core.net.command.servercommands;
+
+import net.minecraft.core.net.command.CommandHandler;
+import net.minecraft.core.net.command.CommandSender;
+import net.minecraft.core.net.command.ServerCommand;
+import net.minecraft.server.MinecraftServer;
+
+public class PardonCommand extends ServerCommand {
+    public PardonCommand(MinecraftServer server) {
+        super(server, "pardon");
+    }
+
+    @Override
+    public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
+        if (args.length != 1) return false;
+        String senderName = sender.getName();
+
+        String nameToPardon = args[0];
+
+        server.playerList.pardonPlayer(nameToPardon);
+        sendNoticeToOps(senderName, "Pardoning " + nameToPardon);
+
+        return true;
+    }
+
+    @Override
+    public boolean opRequired(String[] args) {
+        return true;
+    }
+
+    @Override
+    public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
+        sender.sendMessage("/pardon <username>");
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/servercommands/PardonIpCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/PardonIpCommand.java
new file mode 100644
index 000000000..cfdb32836
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/PardonIpCommand.java
@@ -0,0 +1,35 @@
+package net.minecraft.core.net.command.servercommands;
+
+import net.minecraft.core.net.command.CommandHandler;
+import net.minecraft.core.net.command.CommandSender;
+import net.minecraft.core.net.command.ServerCommand;
+import net.minecraft.server.MinecraftServer;
+
+public class PardonIpCommand extends ServerCommand {
+    public PardonIpCommand(MinecraftServer server) {
+        super(server, "pardon-ip");
+    }
+
+    @Override
+    public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
+        if (args.length != 1) return false;
+        String senderName = sender.getName();
+
+        String nameToPardon = args[0];
+
+        server.playerList.pardonIP(nameToPardon);
+        sendNoticeToOps(senderName, "Pardoning ip " + nameToPardon);
+
+        return true;
+    }
+
+    @Override
+    public boolean opRequired(String[] args) {
+        return true;
+    }
+
+    @Override
+    public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
+        sender.sendMessage("/pardon-ip <username>");
+    }
+}
